//Tranz-Am
#include "game_transam.h"
static bool initial=true;
static FSOUND_STREAM* hsstream=NULL;
static int channel=-1;
static const int windowWidth=220;
static const int windowHeight=75;
static BITMAP* copy=NULL;

static font_struct FunkyFont;
static prop_text_struct FunkyText;
//texture_struct demo_texture;

bool PauseLogic()
{
	static double cycle=0.0;

	//quick thing. if in pause and switch then quit pause on return
	if(initial)
	{
		PFONT_load_font_from_bitmap(&FunkyFont, (BITMAP*)GameDAT[FONTFUNKYMESSAGE].dat, 16, 32);
		//PFONT_load_texture_from_bitmap(&demo_texture , (BITMAP*)GameDAT[FONTFUNKYTEXTURE].dat , 16 , 16 );
		PFONT_create_frame_list (&FunkyText , &FunkyFont ,
			"Game Paused",
			windowWidth, PFONT_ALIGN_CENTER , 1, -6 , false, false );


		copy=create_bitmap(SCREEN_W,SCREEN_H);
		blit(GameFramework->DrawingSurface,copy,0,0,0,0,SCREEN_W,SCREEN_H);
		fblend_rect_trans(copy,0,0,SCREEN_W,SCREEN_H,makecol(0,0,0),196);
		clear_keybuf();
		//hsstream=PlaySampleFromStream((const char*)(GameDAT[MUSIC_MP3_PAUSE].dat),channel,GameConfiguration->CapsSound.MusicVolume,GameDAT[MUSIC_MP3_PAUSE].size,FSOUND_LOADMEMORY | FSOUND_LOOP_NORMAL);
		if(ActiveMusic)
			FMUSIC_SetPaused(ActiveMusic,TRUE);
		initial=false;
	}
	else
	{
		if(keypressed() || GameFramework->JoypadButtonPressed())
		{
			if(ActiveMusic)
				FMUSIC_SetPaused(ActiveMusic,FALSE);
			bool quit=false;
			int currentkey=0;
			if(keypressed())
			{
				currentkey=readkey()>>8;
				if(currentkey==KEY_Q)
					quit=true;
			}
			if(currentkey==KEY_ESC)
				return false;

			initial=true;
			if(copy)
				destroy_bitmap(copy);
			copy=NULL;
			StopStream(hsstream);
			hsstream=NULL;
			channel=-1;
			PFONT_free_font (&FunkyFont);
			//PFONT_free_texture (&demo_texture);
			quitPause=quit;
			return true;
		}
	}
	PFONT_posset_reset ( &FunkyText );
	PFONT_texset_basic_spread ( &FunkyText , 1 , 1 , (float)cycle*16 , (float)cycle*16 , true );

	//slide in out
	PFONT_posmod_scale ( &FunkyText , 0.5 , 0.5 , 1.1+(sin (cycle)/10) , 1.0+(cos (cycle)/10) );

	PFONT_texmod_selection ( &FunkyText, 0.5 + ( (float)(sin (cycle/2)) / 2) ,  0.5 + ( (float)(cos (cycle/2)) / 2) , (int)( float(cos (cycle/6)) * 192.0f) , 0 , 128 , 1 , 0 );

	//move round a little
	//PFONT_posmod_add_noise ( &FunkyText , 0 , 40 );
	PFONT_posmod_inverse_damp_point ( &FunkyText , (int (cycle*15) % 1000)-15 , 150 , 1 );
	PFONT_posmod_bow_in ( &FunkyText , 0.5 , 0.5 , cos (cycle/2) * 20.0 , sin (cycle) * 20.0 );
	//sine wave
	//PFONT_posmod_sine_out_phase ( &FunkyText , 0.02 , 0.02 , -20 , -20 , cycle , cycle );
	//PFONT_posmod_damp_point ( &FunkyText , (int (cycle*2) % 1500)-300 , 300 , 0 );
	cycle+=0.02;
	return false;
}

bool PauseDrawing()
{
	if(copy)
		blit(copy,GameFramework->DrawingSurface,0,0,0,0,SCREEN_W,SCREEN_H);

	fblend_rect_trans(GameFramework->DrawingSurface,SCREEN_W/2-windowWidth,SCREEN_H/2-windowHeight,windowWidth*2,windowHeight*2,makecol(239, 119, 32),246);
	//textout_centre_ex(GameFramework->DrawingSurface,LargeFont2,"Paused",SCREEN_W/2,SCREEN_H/2-50,0,-1);
	textout_centre_ex(GameFramework->DrawingSurface,MainFont2,"Press to Continue",SCREEN_W/2,SCREEN_H/2+10,0,-1);
	textout_centre_ex(GameFramework->DrawingSurface,MainFont2,"Or Q Quits",SCREEN_W/2,SCREEN_H/2+40,0,-1);

	PFONT_draw_frame_list_coloured(&FunkyText ,
		1000 , SCREEN_W/2,
		SCREEN_H/2-55, 0.5 , 0.0 , GameFramework->DrawingSurface,38,95,160);

	return false;
}

