//Tranz-Am
#include "game_transam.h"

using namespace AXL_Projects;

//main library variables
Framework* GameFramework;			//framework
AnimationLibrary* GameLibrary;		//our graphics library
Configuration* GameConfiguration;	//our configuration object
bool FMOD_Enabled=false;
DATAFILE* GameDAT=NULL;
bool ShowingFPS=false;

//main game variables
WayPoint WayPoints[50];
WayPoint PlayerPositions[10];
int CurrentWayPoint=0;
int ScreenXOffset=0;		//where to show the map on screen
int ScreenYOffset=0;
bool OriginalView=true;		//side panel (true) or hud type
int ShownMapWidth=0;	//how big map to show
int ShownMapHeight=0;
int TempLocalRadar=1;
float mapXoff = 0;		//place in map we are at (top left)
float mapYoff = 0;
int KeyboardHandler=0;
int JoystickHandler=0;
//astar map
int* AstarMap=NULL;	//bit array of good/bad blocks
int AStarDistance_StartChase=0;	//distance to start using astar
//int AStarDistance2=0;	//distance to start altering ajustments (small distance)
//int AStarDistance3=0;	//as 2 but for slightly larger
int MaxEnemies=20;
std::string currentMapFile="";
Levels* gameLevels=NULL;
Level* currentLevel=NULL;
bool quitPause=false;
bool musicInGame=false;
bool GlobalReset=false;

//temp debug
float temp1=0.0;
int temp2=0;
int temp3=0;
int temp4=0;

//cup stuff
int NumCups=0;
int MaxNumCups=0;
int CupPositions[TotalMaxNumCups][3];

//graphics
Animation* DisplayPanel=NULL;
Animation* DisplaySpeedo=NULL;
Animation* DisplayTemperature=NULL;
Animation* DisplayFuel=NULL;
Animation* PanelCar=NULL;
Animation* Cup=NULL;
Animation* StartCountdown=NULL;
Animation* RadarUpdate=NULL;
BITMAP* LocalRadar=NULL;
BITMAP* LocalCup=NULL;
BITMAP* LocalCar=NULL;
BITMAP* LocalEnemy=NULL;
BITMAP* LocalMap=NULL;
BITMAP* RadarOff;
BITMAP* RadarWarmup;

/*BITMAP* FontSmall=NULL;
BITMAP* FontMain=NULL;
BITMAP* FontLarge=NULL;
BITMAP* FontMain2=NULL;
BITMAP* FontLarge2=NULL;*/
BITMAP* MenuTitle=NULL;
BITMAP* DisplayedCup=NULL;
BITMAP* MemoryBuffer=NULL;

FONT* OriginalFont=NULL;
FONT* MainFont=NULL;
FONT* LargeFont=NULL;
FONT* MainFont2=NULL;
FONT* LargeFont2=NULL;
FONT* SmallFont=NULL;

bool TempDebug=false;

//car stuff
fix FIX_ANGLE[360];
int Lives=3;
BITMAP* PlayerCars[40];	//9 degree movements

//enemy stuff
EnemyCar* Enemies[TotalMaxEnemies];
BITMAP* EnemyCars[40];	//9 degree movements

BITMAP* ShadowCars[40];	//9 degree movements - car shadow
//race game

//music
FMUSIC_MODULE *ActiveMusic=NULL;

//sfx
FSOUND_SAMPLE *snd_menuchange = NULL;
FSOUND_SAMPLE *snd_menuselect = NULL;
FSOUND_SAMPLE *snd_gamefuelincrease=NULL;
FSOUND_SAMPLE *snd_gamelowfuel=NULL;
FSOUND_SAMPLE *snd_gamehandbrake=NULL;
FSOUND_SAMPLE *snd_gamecarcrash=NULL;
FSOUND_SAMPLE *snd_gamecountdown=NULL;
FSOUND_SAMPLE *snd_gamecarmoving=NULL;
FSOUND_SAMPLE *snd_findcup=NULL;
FSOUND_SAMPLE* snd_gameradar=NULL;


std::string states[51][3]=
{
	{"","",""},
	{"washington","olympia",""},		//1
	{"montana","helena",""},
	{"north dakota","bismarck",""},
	{"oregon","salem",""},
	{"wyoming","cheyenne",""},
	{"idaho","boise",""},
	{"south dakota","pierre",""},
	{"california","sacramento",""},
	{"arizona","phoenix",""},
	{"kansas","topeka",""},			//10
	{"nevada","carson city",""},
	{"new mexico","santa fe",""},
	{"minnesota","st.paul",""},
	{"colorado","denver",""},
	{"texas","austin",""},
	{"iowa","des moines",""},
	{"michigan","lansing",""},
	{"wisconsin","madison",""},
	{"missouri","jefferson city",""},
	{"louisiana","baton rouge",""},	//20
	{"utah","salt lake city",""},
	{"nebraska","lincoln",""},
	{"illinois","springfield",""},
	{"arkansas","little rock",""},
	{"alabama","montgomery",""},
	{"florida","tallahassa",""},
	{"georgia","atlanta",""},
	{"north carolina","raleigh",""},
	{"indiana","indianapolis",""},
	{"ohio","columbus",""},			//30
	{"mississippi","jackson",""},
	{"south carolina","columbia",""},
	{"","",""},						//33
	{"pennsylvania","harrisburg",""},
	{"virginia","richmond",""},
	{"delaware","dover",""},
	{"new york","albany",""},
	{"Maryland","annapolis",""},
	{"new jersey","trenton",""},
	{"conneticut","hartford",""},		//40
	{"kentucky","frankfort",""},
	{"oklahoma","oklahoma city",""},
	{"west virginia","charleston",""},
	{"rhode island","providence",""},
	{"tennessee","nashville",""},
	{"new hampshire","concord",""},
	{"massechusets","boston",""},
	{"main","agusta",""},
	{"vermont","montpelier",""},
	{"Washington D.C.","Washington D.C.",""}	//50
};
